Description

I have a Puppet class that contains :

$listen.each |$port|{

apache::listen{"$port": }

}

If the class has this, it won't appear in the importer.

If the class does not have this, class appears.

I've just installed Foreman and this is the first thing I tried to do and this is not working...

History

#1 - 05/05/2014 12:13 PM - Stephen Benjamin

.each requires `parser = future` configured, is that enabled in the puppet.conf?

http://docs.puppetlabs.com/puppet/latest/reference/experiments_future.html#enabling-the-future-parser

#2 - 05/05/2014 12:17 PM - Stephen Benjamin

Also `parser = future` needs to be in the [master] section not [main] for Foreman, that's due to #5522.

#3 - 05/05/2014 01:27 PM - Vincent Miszczak

I had this option enabled before installing Foreman on my test Puppet. Foreman replaced Puppet configuration and the value was not there anymore.

But if I put `parser = future` in [main], my class won't appear but worst, Foreman wants to remove all my classes !

production     Remove:    apache, ...

#4 - 05/05/2014 01:31 PM - Vincent Miszczak

Vincent Miszczak wrote:

I had this option enabled before installing Foreman on my test Puppet. Foreman replaced Puppet configuration and the value was not there

anymore.

But if I put `parser = future` in [main], my class won't appear but worst, Foreman wants to remove all my classes !

production     Remove:    apache, ...

 You should have read `parser = future` in [*master*] ofc.

#5 - 05/06/2014 07:52 AM - Dominic Cleal

- Project changed from Foreman to Smart Proxy

- Category deleted (Puppet integration)
http://docs.puppetlabs.com/puppet/latest/reference/experiments_future.html#enabling-the-future-parser
https://projects.theforeman.org/issues/5522


If you're using Puppet 3.5 then there's also bug #5239 where our future parser support's currently broken.

#6 - 07/14/2014 01:53 PM - Jason Knudsen

I'm also seeing an issue whereby the foreman_proxy fails to import classes if they have 'future parser' code within.

ENV: CentOS 6.5

Puppet: 3.6.2

Foreman: 1.5.1

Error:

Error while parsing /path/to/init.pp: Could not match |$key, at line 404

Line 404 in init.pp:

each($foreman_api::servers) |$key, $value| {

My current workaround is to create a blank module, run the foreman classes import, then update the module to contain my future parsed code.

#7 - 07/14/2014 01:54 PM - Jason Knudsen

Oh and yes, I have parser = future in the main and master sections of puppet.conf

#8 - 07/14/2014 03:43 PM - Jason Knudsen

Upon further investigation, it seems to be a problem with determining which parser to use when it reads from puppet.conf, it doesn't discover that I'm

using parser = future and continues to use the old parser. It may be something specific to my environment, but if I set eparser = true in the ruby code,

it succeeds to import the class correctly.

#9 - 06/22/2015 11:17 AM - Anonymous

I can't replicate the issue with Puppet 3.8.1: if the "parser" setting in puppet.conf is set to "future", modules containing future-parser compatible syntax

get loaded and parsed as expected.

#10 - 06/23/2015 05:10 AM - Anonymous

- Status changed from New to Feedback

#11 - 05/17/2017 10:36 AM - Anonymous

- Status changed from Feedback to Resolved

no reaction, closing
